<%- include('../partials/header') %>
<%- include('../partials/scripts') %>
<%- include('../partials/select2') %>
</head>

<body class="min-vh-100 d-flex flex-column">
	<%- include('../partials/navbar') %>
	<div class="main-content d-flex flex-column flex-grow-1">
		<%- include('../partials/topbar') %>
		<%- include('./header', { active: 'edit' }) %>
		<!-- Page content -->
		<div class="container-fluid mt--7 flex-grow-1">
			<div class="row">
				<div class="col-xl-12">
					<div class="card">
						<div class="card-header">
							<div class="row align-items-center">
								<div class="col-12">
									<h3 class="mb-0">Editace výsledku</h3>
								</div>
							</div>
						</div>
						<div class="card-body bg-secondary">
							<form action="./" method="POST" id="edit-result">
								<div class="row">
									<div class="col float-left">
										<h6 class="heading text-muted mb-4">Obecné informace</h6>
									</div>
								</div>
								<div class="pl-lg-4">
									<div class="row">
										<div class='col-3'>
											<div class='form-group'>
												<label for='select-type'>Typ</label>
												<select class='form-control' id='select-type'>
													<option value="qualification">Kvalifikace</option>
													<option value="spider">Pavouk</option>
												</select>
											</div>
										</div>
										<div class='col-3'>
											<div class='form-group'>
												<label for='select-team'>Tým</label>
												<select class='form-control' id='select-team'></select>
											</div>
										</div>
										<div class='col-3'>
											<div class='form-group'>
												<label for='select-category'>Kategorie</label>
												<select class='form-control' id='select-category'></select>
											</div>
										</div>
										<div class='col-3'>
											<div class='form-group'>
												<label for='select-style'>Styl</label>
												<select class='form-control' id='select-style'>
													<option value="top">Vrchem</option>
													<option value="bottom">Spodem</option>
												</select>
											</div>
										</div>
									</div>
								</div>
								<div class="pl-lg-4">
									<div class="row">
										<div class="col" id="edit-result-status" style="display: none;"></div>
										<div class="col-4 text-left">
											<button type="submit" class="btn btn-primary"
												id="edit-result-button">Upravit</button>
										</div>
									</div>
								</div>
							</form>
							<form action="./" method="POST" id="edit-result-attempts">
								<div class="row mt-4">
									<div class="col float-left">
										<h6 class="heading text-muted mb-4">Pokusy</h6>
									</div>
									<div class="col float-right">
										<button type="button" onclick="addAttemptRow()"
											class="btn btn-sm btn-primary float-right">Přidat políčko pokusu</button>
									</div>
								</div>
								<div class="pl-lg-4">
									<div id="attempts">
										<% for( let i = 0; i < result.attempts.length; i++ ) { %>
										<div class="row">
											<div class="col-md-11 col-sm-12">
												<div class="form-group">
													<label class="form-control-label" for="attempt-<%= i %>">
														Pokus č. <%= i+1 %>
													</label>
													<input class="form-control" id="attempt-<%= i %>"
														required="required" type="number"
														placeholder="Zadejte čas pokusu"
														value="<%= result.attempts[i] %>" step="0.01">
												</div>
											</div>
											<div class="col-1 m-auto">
												<button class="btn btn-danger m-auto" type="button"
													onclick="$(this).parent().parent().remove()">×</button>
											</div>
										</div>
										<% } %>
									</div>
									<div class="row">
										<div class="col" id="edit-result-attempts-status" style="display: none;"></div>
										<div class="col-4 text-left">
											<button type="submit" class="btn btn-primary"
												id="edit-result-button">Upravit</button>
										</div>
									</div>
								</div>
							</form>
						</div>
					</div>
				</div>
			</div>
			<%- include('../partials/footer') %>
		</div>
	</div>
	<%- include('../partials/scripts-file-end') %>
	<script>
		function addAttemptRow(i = $('div#attempts .row').length, motherDOM = $('div#attempts')) {
			$('<div>', { class: 'row' }).append(
				$('<div>', { class: 'col-md-11 col-sm-12' }).append(
					$('<div>', { class: 'form-group' }).append(
						$('<label>', { class: 'form-control-label', for: `attempt-${i}` }).text(`Pokus č. ${i + 1}`),
						$('<input>', { class: 'form-control', id: `attempt-${i}`, required: 'required', type: 'number', placeholder: 'Zadejte čas pokusu', step: "0.01" })
					)
				),
				$('<div>', { class: 'col-1 m-auto' }).append(
					$('<button>', { class: 'btn btn-danger m-auto', type: 'button', onclick: '$(this).parent().parent().remove()' }).html('&times;')
				)
			).appendTo(motherDOM)
		}

		function getAttemptsForRequest() {
			let attempts = []
			for (let i = 0; i < $('div#attempts .row').length; i++) {
				attempts.push($(`input#attempt-${i}`).val())
			}
			return attempts
		}

		$(document).ready(() => {
			let $selectType = $('select#select-type').select2({
				minimumResultsForSearch: -1
			})
			$selectType.val('<%= result.type %>')
			$selectType.trigger('change')

			let $selectTeam = $('select#select-team').select2()
			$selectTeam.html(`<option selected="selected" value>Načítání...</option>`)
			$selectTeam.prop("disabled", true);
			API.team.list().done((listOfTeams) => {
				$selectTeam.html(`<option selected="selected" value disabled="disabled">Vyber tým</option>`)
				listOfTeams.forEach((team) => {
					$selectTeam.append(`<option value="${team._id}">${team.name}</option>`)
				})
				$selectTeam.prop("disabled", false);
				$selectTeam.on('select2:select', function (e) {
					$selectCategory
						.val(listOfTeams.filter(team => {
							return team._id === $selectTeam.val()
						})[0].category._id)
						.prop('disabled', true)
						.trigger('change')
				})
			}).then(function (params) {
				$selectTeam.val('<%= result.team._id %>')
				$selectTeam.trigger('change')
				$selectCategory.val('<%= result.team.category._id %>')
				$selectCategory.trigger('change')
			})

			let $selectCategory = $('select#select-category').select2({
				minimumResultsForSearch: -1
			})
			$selectCategory.html(`<option selected="selected" value>Načítání...</option>`)
			API.category.list().done((listOfCategories) => {
				$selectCategory.html(`<option selected="selected" value disabled="disabled">Po vybrání týmu se vybere kategorie</option>`)
				listOfCategories.forEach((category) => {
					$selectCategory.append(`<option value="${category._id}">${category.name}</option>`)
				})
			})
			$selectCategory.val('<%= result.category._id %>')
			$selectCategory.trigger('change')
			$selectCategory.prop("disabled", true);

			let $selectStyle = $('select#select-style').select2({
				minimumResultsForSearch: -1
			})
			$selectStyle.val('<%= result.style %>')
			$selectStyle.trigger('change')

			$('form#edit-result').submit(function (event) {
				event.preventDefault()
				let $status = $('div#edit-result-status')
				$status
					.empty()
					.append(
						$('<div>', { class: 'alert alert-default alert-dismissible fade show', role: 'alert' }).append(
							$('<span>', { class: 'alert-icon' }).append(
								$('<i>', { class: 'fas fa-circle-notch fa-spin' })
							),
							$('<span>', { class: 'alert-text' }).append(
								'Zpracovávám'
							),
							$('<button>', { type: 'button', class: 'close', 'data-dismiss': 'alert', 'aria-label': 'Close' }).append(
								$('<span>', { 'aria-hidden': 'true' }).html('&times;')
							)
						)
					)
					.show()

				API.result
					.edit(
						'<%= result._id %>',
						{
							type: $selectType.val(),
							team: $selectTeam.val(),
							category: $selectCategory.val(),
							style: $selectStyle.val()
						}
					).done(function (responseFromServer) {
						if (responseFromServer === 'ok') {
							$status
								.empty()
								.append(
									$('<div>', { class: 'alert alert-success alert-dismissible' }).append(
										$('<a>', { href: '#', class: 'close', 'data-dismiss': 'alert', 'aria-label': 'close' }).html('&times;'),
										$('<strong>').text('Gratuluji!'),
										' Úspěšně jste upravil(a) výsledek'
									)
								)
								.show()

							// Refresh
							setTimeout(function () {
								window.location.href = window.location.href;
							}, 3500)
						} else {
							$status
								.empty()
								.append(
									$('<div>', { class: 'alert alert-danger alert-dismissible' }).append(
										$('<a>', { href: '#', class: 'close', 'data-dismiss': 'alert', 'aria-label': 'close' }).html('&times;'),
										$('<strong>').text('Ach ne! '),
										responseFromServer
									)
								)
								.show()
						}
					})
			})

			if ($('div#attempts .row').length < 3 && $selectType.val() === 'qualification') {
				addAttemptRow()
			} else if ($('div#attempts .row').length === 0 && $selectType.val() === 'spider') {
				addAttemptRow()
			}
			$('form#edit-result-attempts').submit(function (event) {
				event.preventDefault()
				let $status = $('div#edit-result-attempts-status')
				$status
					.empty()
					.append(
						$('<div>', { class: 'alert alert-default alert-dismissible fade show', role: 'alert' }).append(
							$('<span>', { class: 'alert-icon' }).append(
								$('<i>', { class: 'fas fa-circle-notch fa-spin' })
							),
							$('<span>', { class: 'alert-text' }).append(
								'Zpracovávám'
							),
							$('<button>', { type: 'button', class: 'close', 'data-dismiss': 'alert', 'aria-label': 'Close' }).append(
								$('<span>', { 'aria-hidden': 'true' }).html('&times;')
							)
						)
					)
					.show()

				API.result
					.edit(
						'<%= result._id %>',
						{
							attempts: getAttemptsForRequest()
						}
					).done(function (responseFromServer) {
						if (responseFromServer === 'ok') {
							$status
								.empty()
								.append(
									$('<div>', { class: 'alert alert-success alert-dismissible' }).append(
										$('<a>', { href: '#', class: 'close', 'data-dismiss': 'alert', 'aria-label': 'close' }).html('&times;'),
										$('<strong>').text('Gratuluji!'),
										' Úspěšně jste upravil(a) pokusy'
									)
								)
								.show()

							// Refresh
							setTimeout(function () {
								window.location.href = window.location.href;
							}, 3500)
						} else {
							$status
								.empty()
								.append(
									$('<div>', { class: 'alert alert-danger alert-dismissible' }).append(
										$('<a>', { href: '#', class: 'close', 'data-dismiss': 'alert', 'aria-label': 'close' }).html('&times;'),
										$('<strong>').text('Ach ne! '),
										responseFromServer
									)
								)
								.show()
						}
					})
			})
		})
	</script>
	<%- include('../partials/file-end') %>
